package eu.pretix.libpretixsync.utils

fun cleanInput(raw_input: String, source_type: String): String {
    var cleaned = raw_input.replace(Regex("[\\p{C}]"), "�")  // remove unprintable characters
    if (source_type == "barcode") {
        // Remove ECI flag for Latin-1 which is prepended by some barcode scanners to QR codes
        // generated by the app "WalletPasses" even though it is the default encoding.
        // https://en.wikipedia.org/wiki/Extended_Channel_Interpretation
        cleaned = cleaned.removePrefix("\\000001")
    }
    return cleaned
}